#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"

// LED_p^[p}N
#define Pattern_1 0xFF
#define Pattern_2 0x00
#define Pattern_3 0xF0
#define Pattern_4 0x0F

// XCb`LED̓_p^[ύX
void main(void) {
	// LED_p^[
	char State;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpɃ|[gD, |[gCgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
	// : XCb`pɃ|[gBgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);

	// PD0`PD3, PC4`PC7o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, 0x0F);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, 0xF0);

	// PB2`PB5̓^Cvɐݒ
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_2);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_3);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_4);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_5);

	// _p^[̏lZbg
	State = 0xFF;

	while (1) {
		// PSW1Ăꍇ
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_2) == 0) {
			// _p^[1Zbg
			State = Pattern_1;
		}
		// PSW2Ăꍇ
		else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_3) == 0) {
			// _p^[2Zbg
			State = Pattern_2;
		}
		// PSW3Ăꍇ
		else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_4) == 0) {
			// _p^[3Zbg
			State = Pattern_3;
		}
		// PSW4Ăꍇ
		else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_5) == 0) {
			// _p^[4Zbg
			State = Pattern_4;
		}
		// eLEDɓ_p^[Zbg
		GPIOPinWrite(GPIO_PORTD_BASE, 0x0F, State);
		GPIOPinWrite(GPIO_PORTC_BASE, 0xF0, State);
	}
}
